Subject: Re: GRO aggregation

From: Rick Jones <[email-masked]>
Date: Wed, 12 Sep 2012 09:52:05 -0700

On 09/12/2012 09:34 AM, Shlomo Pongartz wrote:
> On 9/12/2012 7:23 PM, Rick Jones wrote:
>> On 09/12/2012 07:41 AM, Shlomo Pongartz wrote:
>>> Hi Eric
>>>
>>> The TSO is just a mean to create a burst of frames on the wire so the
>>> NAPI will be able to pool as much as possible.
>>
>> Is it?  If I recall correctly, TSO was in place well before all
>> drivers were using NAPI.  And NAPI was being proposed independent of
>> TSO. TSO is there to save CPU cycles on the transmit side.  "On the
>> wire" what it sends is to be identical to what a host with greater CPU
>> performance could accomplish.
>>
>> rick jones
>>
> Hi Rick.
>
> What I say is that I use TSO on the machine that transmits so I'll have
> a burst of frames on the wire for the NAPI on the receiver machine.

Also, NAPI was in place before GRO.  IIRC, the napi code was simply a 
convenient/correct/natural place to have the GRO functionality.

rick jones